<?php

namespace Lc\CaracoleBundle\Builder\User;

use Doctrine\ORM\EntityManagerInterface;
use Lc\CaracoleBundle\Factory\User\UserPointSaleFactory;
use Lc\CaracoleBundle\Model\PointSale\PointSaleInterface;
use Lc\SovBundle\Model\User\UserInterface;

class UserBuilder
{
    protected EntityManagerInterface $entityManager;

    public function __construct(EntityManagerInterface $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function linkToPointSale(UserInterface $user, PointSaleInterface $pointSale)
    {
        if (!$user->isLinkedToPointSale($pointSale)) {
            $userPointSaleFactory = new UserPointSaleFactory();
            $userPointSale = $userPointSaleFactory->create($user, $pointSale);

            $this->entityManager->persist($userPointSale);
            $this->entityManager->flush();

            return true;
        }

        return false;
    }
}

